(function(e){if("function"==typeof bootstrap)bootstrap("hamster",e);else if("object"==typeof exports)module.exports=e();else if("function"==typeof define&&define.amd)define(e);else if("undefined"!=typeof ses){if(!ses.ok())return;ses.makeHamster=e}else"undefined"!=typeof window?window.hamster=e():global.hamster=e()})(function(){var define,ses,bootstrap,module,exports;
return (function(e,t,n){function i(n,s){if(!t[n]){if(!e[n]){var o=typeof require=="function"&&require;if(!s&&o)return o(n,!0);if(r)return r(n,!0);throw new Error("Cannot find module '"+n+"'")}var u=t[n]={exports:{}};e[n][0].call(u.exports,function(t){var r=e[n][1][t];return i(r?r:t)},u,u.exports)}return t[n].exports}var r=typeof require=="function"&&require;for(var s=0;s<n.length;s++)i(n[s]);return i})({1:[function(require,module,exports){
"use strict";

var Hamster = require('./lib/Hamster');

module.exports = new Hamster();
module.exports.Hamster = Hamster;

},{"./lib/Hamster":2}],2:[function(require,module,exports){
"use strict";

/**
 * The difference between a Hamster and a Cache is that the hamster manages
 * a group of cache objects, called like cache(fun), while the result of
 * afformentioned call is a cache object which caches the result of every
 * unique call.
 */


/* Vars
============================================================================= */

var utils = require('./utils'),
    extend = utils.extend,
    DEFAULTS = require('./defaults'),
    Cache = require('./Cache'),
    Hamster;


/* Class constructor
============================================================================= */

/**
 * Hamster(options)
 *
 * Create a new Hamster instance with optional default cache options. Manages
 * cached functions.
 *
 * @param options (object) Options
 * @return (Function&this) A Hamster instance extended on a function for
 *  creating caches.
 */

module.exports = exports = Hamster = function Hamster (options) {
  var cache;

  // Extend default options
  this.options = extend({}, DEFAULTS, options);
  this.caches = [];

  // Extend handler with self
  /*jshint proto:true*/
  cache = extend(handler.bind(this), this);
  cache.__proto__ = this.__proto__;

  return cache;
};


/* Public methods
============================================================================= */


/**
 * Hamster()
 *
 * The "this" of a hamster instance is also callable! Creates a new cache for
 * the supplied function. See the Cache constructor.
 */

function handler (fn, options) {
  /*jshint validthis:true */

  var cache,
      // Extend default options
      settings = extend({}, this.options, options);

  cache = new Cache(fn, settings);
  this.caches.push(cache);
  return cache;
}


/**
 * Hamster.sync()
 *
 * The same as Hamster() but with { async: false } preset
 */

Hamster.prototype.sync = function(fn, options) {
  return this(fn, extend({ async: false }, options));
};


/**
 * Hamster.async()
 *
 * The same as Hamster() but with { async: true } preset
 */

Hamster.prototype.async = function(fn, options) {
  return this(fn, extend({ async: true }, options));
};

},{"./defaults":3,"./utils":4,"./Cache":5}],3:[function(require,module,exports){
"use strict";

module.exports = {
  async: true,
  ttl: 10000,
  maxSize: 50,
  keys: []
};

},{}],4:[function(require,module,exports){
"use strict";


// Extend stuff
exports.extend = function extend () {
  var objs = Array.prototype.slice.call(arguments),
      rootObj = objs.shift() || {};

  objs.forEach(function (obj) {
    if(obj) {
      Object.keys(obj).forEach(function (i) {
        rootObj[i] = obj[i];
      });
    }
  });

  return rootObj;
};

exports.cloneFn = function cloneFn (fn) {
  var args,
      strFn = fn.toString();

  // Extract argument names
  // Match first occurence of "(<anything but end-parenthesis>)",
  // split it on "," and use as args
  args = [Function].concat(strFn
    .match(/\(([^\)]*)\)/)[1]
    .trim()
    .split(/\s*,\s*/)
    .filter(Boolean));

  // Extract function body
  // Find first "{" and last "}" and grab everything inbetween
  args.push(strFn.substring(strFn.indexOf('{') + 1, strFn.lastIndexOf('}')));

  // Create and return the new function
  return new (Function.bind.apply(Function, args))();
};

exports.optionalCallback = function (callback /*, args*/) {
  var args = Array.prototype.slice.call(arguments, 1);

  if(callback) {
    callback.apply(null, args);
  }

  // If more than one argument, return last
  return args[args.length - 1];
};

exports.extendProto = function (target, source) {
  var props = Object.getOwnPropertyNames(source);

  props.forEach(function (prop) {
    target[prop] = source[prop];
  });

  return target;
};

},{}],6:[function(require,module,exports){
"use strict";


/**
 * Queue
 *
 * Keep track of which caches are being updated and provide an api for 
 *
 * @param paramName (type) Description
 * @return (type) Description
 */

var EventEmitter = require('events').EventEmitter,
    Queue;


module.exports = exports = Queue = function Queue () {
  this.queued = {};
  this.events = new EventEmitter();
};

Queue.prototype.isFetching = function(key) {
  return key in this.queued;
};

Queue.prototype.startFetching = function(key) {
  this.queued[key] = true;
  return true;
};

Queue.prototype.stopFetching = function(key, result) {
  delete this.queued[key];
  return this.events.emit(key, result);
};

Queue.prototype.wait = function(key, callback) {
  return this.events.once(key, callback);
};

},{"events":7}],8:[function(require,module,exports){
// shim for using process in browser

var process = module.exports = {};

process.nextTick = (function () {
    var canSetImmediate = typeof window !== 'undefined'
    && window.setImmediate;
    var canPost = typeof window !== 'undefined'
    && window.postMessage && window.addEventListener
    ;

    if (canSetImmediate) {
        return function (f) { return window.setImmediate(f) };
    }

    if (canPost) {
        var queue = [];
        window.addEventListener('message', function (ev) {
            if (ev.source === window && ev.data === 'process-tick') {
                ev.stopPropagation();
                if (queue.length > 0) {
                    var fn = queue.shift();
                    fn();
                }
            }
        }, true);

        return function nextTick(fn) {
            queue.push(fn);
            window.postMessage('process-tick', '*');
        };
    }

    return function nextTick(fn) {
        setTimeout(fn, 0);
    };
})();

process.title = 'browser';
process.browser = true;
process.env = {};
process.argv = [];

process.binding = function (name) {
    throw new Error('process.binding is not supported');
}

// TODO(shtylman)
process.cwd = function () { return '/' };
process.chdir = function (dir) {
    throw new Error('process.chdir is not supported');
};

},{}],7:[function(require,module,exports){
(function(process){if (!process.EventEmitter) process.EventEmitter = function () {};

var EventEmitter = exports.EventEmitter = process.EventEmitter;
var isArray = typeof Array.isArray === 'function'
    ? Array.isArray
    : function (xs) {
        return Object.prototype.toString.call(xs) === '[object Array]'
    }
;
function indexOf (xs, x) {
    if (xs.indexOf) return xs.indexOf(x);
    for (var i = 0; i < xs.length; i++) {
        if (x === xs[i]) return i;
    }
    return -1;
}

// By default EventEmitters will print a warning if more than
// 10 listeners are added to it. This is a useful default which
// helps finding memory leaks.
//
// Obviously not all Emitters should be limited to 10. This function allows
// that to be increased. Set to zero for unlimited.
var defaultMaxListeners = 10;
EventEmitter.prototype.setMaxListeners = function(n) {
  if (!this._events) this._events = {};
  this._events.maxListeners = n;
};


EventEmitter.prototype.emit = function(type) {
  // If there is no 'error' event listener then throw.
  if (type === 'error') {
    if (!this._events || !this._events.error ||
        (isArray(this._events.error) && !this._events.error.length))
    {
      if (arguments[1] instanceof Error) {
        throw arguments[1]; // Unhandled 'error' event
      } else {
        throw new Error("Uncaught, unspecified 'error' event.");
      }
      return false;
    }
  }

  if (!this._events) return false;
  var handler = this._events[type];
  if (!handler) return false;

  if (typeof handler == 'function') {
    switch (arguments.length) {
      // fast cases
      case 1:
        handler.call(this);
        break;
      case 2:
        handler.call(this, arguments[1]);
        break;
      case 3:
        handler.call(this, arguments[1], arguments[2]);
        break;
      // slower
      default:
        var args = Array.prototype.slice.call(arguments, 1);
        handler.apply(this, args);
    }
    return true;

  } else if (isArray(handler)) {
    var args = Array.prototype.slice.call(arguments, 1);

    var listeners = handler.slice();
    for (var i = 0, l = listeners.length; i < l; i++) {
      listeners[i].apply(this, args);
    }
    return true;

  } else {
    return false;
  }
};

// EventEmitter is defined in src/node_events.cc
// EventEmitter.prototype.emit() is also defined there.
EventEmitter.prototype.addListener = function(type, listener) {
  if ('function' !== typeof listener) {
    throw new Error('addListener only takes instances of Function');
  }

  if (!this._events) this._events = {};

  // To avoid recursion in the case that type == "newListeners"! Before
  // adding it to the listeners, first emit "newListeners".
  this.emit('newListener', type, listener);

  if (!this._events[type]) {
    // Optimize the case of one listener. Don't need the extra array object.
    this._events[type] = listener;
  } else if (isArray(this._events[type])) {

    // Check for listener leak
    if (!this._events[type].warned) {
      var m;
      if (this._events.maxListeners !== undefined) {
        m = this._events.maxListeners;
      } else {
        m = defaultMaxListeners;
      }

      if (m && m > 0 && this._events[type].length > m) {
        this._events[type].warned = true;
        console.error('(node) warning: possible EventEmitter memory ' +
                      'leak detected. %d listeners added. ' +
                      'Use emitter.setMaxListeners() to increase limit.',
                      this._events[type].length);
        console.trace();
      }
    }

    // If we've already got an array, just append.
    this._events[type].push(listener);
  } else {
    // Adding the second element, need to change to array.
    this._events[type] = [this._events[type], listener];
  }

  return this;
};

EventEmitter.prototype.on = EventEmitter.prototype.addListener;

EventEmitter.prototype.once = function(type, listener) {
  var self = this;
  self.on(type, function g() {
    self.removeListener(type, g);
    listener.apply(this, arguments);
  });

  return this;
};

EventEmitter.prototype.removeListener = function(type, listener) {
  if ('function' !== typeof listener) {
    throw new Error('removeListener only takes instances of Function');
  }

  // does not use listeners(), so no side effect of creating _events[type]
  if (!this._events || !this._events[type]) return this;

  var list = this._events[type];

  if (isArray(list)) {
    var i = indexOf(list, listener);
    if (i < 0) return this;
    list.splice(i, 1);
    if (list.length == 0)
      delete this._events[type];
  } else if (this._events[type] === listener) {
    delete this._events[type];
  }

  return this;
};

EventEmitter.prototype.removeAllListeners = function(type) {
  if (arguments.length === 0) {
    this._events = {};
    return this;
  }

  // does not use listeners(), so no side effect of creating _events[type]
  if (type && this._events && this._events[type]) this._events[type] = null;
  return this;
};

EventEmitter.prototype.listeners = function(type) {
  if (!this._events) this._events = {};
  if (!this._events[type]) this._events[type] = [];
  if (!isArray(this._events[type])) {
    this._events[type] = [this._events[type]];
  }
  return this._events[type];
};

})(require("__browserify_process"))
},{"__browserify_process":8}],5:[function(require,module,exports){
"use strict";


/* Vars
============================================================================= */

var utils = require('./utils'),
    Queue = require('./Queue'),
    cloneFn = utils.cloneFn,
    extend = utils.extend,
    extendProto = utils.extendProto,
    optionalCallback = utils.optionalCallback,
    findBypath = require('findBypath'),
    Reol = require('reol'),
    Cache;


/* Class constructor
============================================================================= */

/**
 * Cache
 *
 * Create a new cached function with optional options (though most times sensible
 * defaults are set through a Hamster instance).
 *
 * @param fn (Function) The function to cache
 * @param [options] (Object) Any settings
 * @return (Function&Cache) A cache function/object. Should replace your own 
 * function
 */

module.exports = exports = Cache = function Cache (fn, options) {
  /*jshint proto:true*/
  var self = this,
      handler;

  self.original = fn;
  self.options = options;
  self.fetchQueue = new Queue();
  self.caches = new Reol({
    key: {}
  });

  // Use either async or sync call handler, wrapped in a context preserving function
  handler = (function (handler) {
    return function () {
      return handler.call(self, this, arguments);
    };
  }(options.async && self.async || self.sync));

  // Extend call handler with self
  handler = extend(handler, self);
  handler.__proto__ = self.__proto__;

  // Keep the original function's prototype
  extendProto(handler.__proto__, fn.__proto__);

  return handler;
};


/* Public methods
============================================================================= */

/**
 * Cache.async()
 *
 * Internal call handler for asynchronous functions.
 *
 * @param context (Object) Context of the caller
 * @param arguments (Array|Arguments) Arguments of the caller
 *  @param callback (Function) The last of the arguments must be a callback
 * @callback (mixed) The result of the cached function
 */

Cache.prototype.async = function(context, originalArguments) {
  var self = this,
      args = [].slice.call(originalArguments),
      callback = args.pop(),
      key = self.makeKey(args);

  self.hasCache(key, function (has) {
    if(has) {
      self.getCache(key, callback.apply.bind(callback, null));
    }
    else {
      self.fetch(context, key, args, function (result) {
        callback.apply(null, result);
      });
    }
  });
};


/**
 * Cache.sync()
 *
 * Internal call handler for synchronous functions.
 *
 * @param context (Object) Context of the caller
 * @param arguments (Array|Arguments) Arguments of the caller
 * @return (mixed) The result of the cached function
 */

Cache.prototype.sync = function(context, args) {
  var key = this.makeKey(args);

  if(this.hasCache(key)) {
    return this.getCache(key);
  }
  else {
    return this.fetch(context, key, args);
  }
};


/**
 * Cache.makeKey()
 *
 * Generates a string from caller arguments to be able to distinguish between
 * unique (or not) calls. Uses Cache.keys, if set, to filter out only relevant
 * properties.
 *
 * @param args (Array|Object) Arguments to stringify
 * @return (String) Stringified arguments
 */

Cache.prototype.makeKey = function(args) {
  var result = args;

  if(this.options.keys.length) {
    result = this.options.keys.map(function (path) {
      return findBypath(args, path);
    });
  }

  return JSON.stringify(result);
};


/**
 * Cache.hasCache()
 *
 * Checks if a cache is saved for a key
 *
 * @param key (String) The stringified arguments
 * @param [callback] (Function)
 * @return (Boolean) Whether it exists or not
 */

Cache.prototype.hasCache = function(key, callback) {
  return optionalCallback(callback, this.caches.findOne({ key: key }));
};


/**
 * Cache.getCache()
 *
 * Retrieve a cache saved for a certain key
 *
 * @param key (String) The stringified arguments
 * @param [callback] (Function)
 * @return (Array|Mixed) The result of the cached function
 */

Cache.prototype.getCache = function(key, callback) {
  var collection = this.caches.find({ key: key }),
      result = collection[0];

  // "touch" the cache (prevent it from being lru)
  collection.remove();
  this.caches.push(result);

  return optionalCallback(callback, result.result);
};


/**
 * Cache.fetch()
 *
 * Call the original function and update the cache
 *
 * @param context (Object|null) Callers original context
 * @param key (string) The stringified arguments
 * @param args (Array|Object) The arguments of the caller
 * @param [callback] (Function) Optional callback
 * @return (mixed) THe result of the original function
 */

Cache.prototype.fetch = function(context, key, args, callback) {
  var that = this,
      result;

  if(callback) {
    // Only fetch if not already being fetched
    if(that.fetchQueue.isFetching(key)) {
      that.fetchQueue.wait(key, function (result) {
        callback(result);
      });
    }
    else {
      that.fetchQueue.startFetching(key);
      // Use callback as argument
      that.original.apply(context, args.concat(done));
    }
  }
  else {
    // If sync, store and return result
    result = that.original.apply(context, args);
    that.store(key, result);
    return result;
  }

  // This callback is used if async
  function done () {
    that.fetchQueue.stopFetching(key, arguments);
    that.store(key, arguments, callback);
  }
};


/**
 * Cache.store()
 *
 * Saves the result of the original function in the cache
 *
 * @param key (String) The stringified arguments
 * @param result (mixed) The result of the original function
 * @param callback (String) Optional callback
 * @return (mixed) The same inputted result
 */

Cache.prototype.store = function(key, result, callback) {
  // Kick LRU (Least Recently Updated)
  if(this.options.lru && this.caches.length >= this.options.lru) {
    this.caches.shift();
  }

  this.caches.push({
    key: key,
    result: result
  });
  this.addTimeout(key);

  // Support callback, allows replacing this method with own store method
  return optionalCallback(callback, result);
};


/**
 * Cache.addTimeout()
 *
 * Mark a cache for clearing when TTL has expired
 *
 * @param key (String) The stringified arguments
 */

Cache.prototype.addTimeout = function(key) {
  if(this.options.ttl) {
    //## It's probably more memory-efficient to use some kind of central
    // timeout and a loop or something
    setTimeout(this.clear.bind(this, key), this.options.ttl);
  }
};


/**
 * Cache.clear()
 *
 * Removes a cached result
 *
 * @param key (String) The stringified arguments
 */

Cache.prototype.clear = function(key) {
  this.caches.find({ key: key }).remove();
};

},{"./utils":4,"./Queue":6,"findBypath":9,"reol":10}],9:[function(require,module,exports){
"use strict";

module.exports = function (element, path, separator) {
  var next, _element;

  separator = separator !== undefined ? separator : '.';
  
  path = path.split(separator);
  _element = element;
  
  while(path.length && _element) {
    next = path.shift();
    _element = _element[next];
  }
  
  return _element;
};

},{}],10:[function(require,module,exports){
(function(){"use strict";
module.exports = require('./lib/Reol');
/*jshint expr:true*/
/*global window:true*/
typeof window !== 'undefined' && (window.Reol = module.exports);

})()
},{"./lib/Reol":11}],11:[function(require,module,exports){
"use strict";

var List = require('./List'),
    Index = require('./Index'),
    Bucket = require('./Bucket'),
    extend = List.extend;

/**
 * Reol
 *
 * An array with multiple user-specified indexes. Slower to write, faster to read.
 * Made for the cases where you initialize a huge array of objects and frequently
 * whish to find those with a specific property and value.
 *
 * @param fields (object) List of fields you whish to index
 * @return (Object) this
 */

function Reol (fields) {
  var field;

  this.index = {};
  this.fields = fields;

  // Define indexes
  for(field in fields) {
    this.index[field] = new Index(extend(fields[field], { index: field, source: this }));
  }

  return this;
}

// Expose helper classes, just to be nice
Reol.List = List;
Reol.Bucket = Bucket;
Reol.Index = Index;


/* Public methods
============================================================================= */

Reol.prototype = new List();
Reol.prototype.constructor = Reol;

/**
 * .add()
 *
 * Add an element. Currently only supports a special kind of unique index which
 * will only reject duplicates from the violating index, but keep the element
 * in other indexes and in the list.
 *
 * @param element (Object) Object to be indexed
 * @return (Reol) this
 */

Reol.prototype.add = function(element, _where) {
  var err, field;

  if(typeof element !== 'object') {
    throw new Error('Sorry, this class only works with objects.');
  }

  // Add to list
  List.prototype.add.call(this, element, _where);

  // Add to indexes
  for(field in this.index) {
    this.index[field].add(element);
  }

  return this;
};


/**
 * .find()
 *
 * Find all elements matching the conditions.
 * an array with one element.
 *
 * @param conditions (object) One (1!) condition to match. Multiple conditions will
 *  be supported later.
 * @param [one] (Boolean) If true will only return one element
 * @return (Array|Object|undefined) The found elements
 */

Reol.prototype.find = function(conditions, one) {
  var key, condition, result;

  // Extract property name
  for(condition in conditions) {
    if(conditions[condition]) {
      key = condition;
      break;
    }
  }

  // Return eveything
  if(!key) {
    return this.toArray();
  }

  // Find in index
  if(this.index[key]) {
    result = this.findInIndex(key, conditions[key]);
  }
  // Find in list
  else {
    result = this.findInList(key, conditions[key], one);
  }

  return result;
};


/**
 * .findOne()
 *
 * Find exactly zero or one element. Should be a tiny bit faster than .find().
 *
 * @param conditions (Object) One (1!) condition to match. Multiple conditions will
 *  be supported later.
 * @return (Object|undefined) The element found if found
 */

Reol.prototype.findOne = function(conditions) {
  return this.find(conditions, true)[0];
};


/**
 * .findInIndex()
 *
 * Find an element in a specified index. Use this without being sure that the
 * index exists and the sky will fall on your head.
 *
 * @param key (string) The name of the index/field to match
 * @param value (string) The value to match
 * @return (Array) Found elements.
 */

Reol.prototype.findInIndex = function (key, value) {
  return this.index[key].find(value);
};


/**
 * .clone()
 *
 * Modification of List.clone() since Reol is a bit special. Creates a new instance
 *
 * @return (Reol) The new instance
 */

Reol.prototype.clone = function() {
  var result = new this.constructor(this.fields);
  result.merge(this);
  return result;
};


/**
 * .remove()
 *
 * Extends List.remove() to propagate to indexes
 */

Reol.prototype.remove = function(elements) {
  var i;

  elements = elements || this.clone();

  List.prototype.remove.call(this, elements, true);

  for(i in this.index) {
    this.index[i].remove(elements, true);
  }
};


module.exports = Reol;

},{"./List":12,"./Index":13,"./Bucket":14}],12:[function(require,module,exports){
"use strict";

var List;

/**
 * List
 *
 * "Class" inherited by all other array-like objects to provide some common
 * methods.
 */

exports = module.exports = List = function List (options, defaults) {
  this.options = {};
  List.extend(this.options, defaults, options);
};


/* Static methods
============================================================================= */

// Find a property by path, eg "level1.level2"
List.findByPath = function (element, path) {
  var next, _element;
  
  path = path.split('.');
  _element = element;
  
  while(path.length && _element) {
    next = path.shift();
    _element = _element[next];
  }
  
  return _element;
};

// Shallow copy of objects
List.extend = function (target) {
  var sources = [].slice.call(arguments, 1),
      source, prop;

  while(sources.length > 0) {
    source = sources.shift();

    for(prop in source) {
      if(source.hasOwnProperty(prop)) {
        target[prop] = source[prop];
      }
    }
  }

  return target;
};


/* Public methods
============================================================================= */

List.prototype = [];
List.prototype.constructor = List;

/**
 * .add(Object)
 *
 * Basic add. Most subclasses will overwrite it
 */

List.prototype.add = function(element, _where) {
  _where = Number(_where);

  if(isNaN(_where)) {
    Array.prototype.push.call(this, element);
  }
  else {
    Array.prototype.splice.call(this, _where, 0, element);
  }
};


/**
 * .merge()
 *
 * Adds all elements in an Array or another instance of List.
 *
 * @param elements (List|Array) Elements to merge
 * @return (Object) this
 */

List.prototype.merge = function(elements) {
  var i, l;

  for(i = 0, l = elements.length; i < l; i++) {
    this.add(elements[i]);
  }

  return this;
};


/**
 * .findInList()
 *
 * Justa naive search through all elements until a match is found
 *
 * @param key (string) The name of the index/field to match
 * @param value (string) The value to match
 * @param [one] (string) If true will return on first match
 * @return (Array) Found elements.
 */

List.prototype.findInList = function(key, value, one) {
  var i, l, result = new List({ source: this.options.source }), list = this;

  for(i = 0, l = list.length; i < l; i++) {
    if(list[i][key] === value) {
      if(one) {
        return list[i];
      }

      result.push(list[i]);
    }
  }

  return result;
};


/**
 * .toArray()
 *
 * Returning a copy of this as an array.
 *
 * @return (Array) Everything
 */

List.prototype.toArray = function() {
  return [].slice.call(this);
};


/**
 * .clone()
 *
 * Make a clone of the object, preserving the instance's settings but dropping
 * relations to any source.
 *
 * @return (List) The new instance
 */

List.prototype.clone = function() {
  var result = new this.constructor(this.options);

  delete result.options.source;
  result.merge(this);

  return result;
};


/**
 * .remove()
 *
 * Remove elements from the list. If the list has a source the remove command
 * will be called on the source, and remove will be called
 * on that list with the supplied element as argument. If no element is supplied
 * all elements in the list will be removed. Use .clone() to not remove elements
 * from the source.
 *
 * @param [elements] (Object) Element(s) to remove
 * @return (Object) The same list it was called on
 */

List.prototype.remove = function(elements, _fromParent) {
  var i, elementIndex;

  elements = elements || this.clone();

  if(!_fromParent && this.options.source) {
    this.options.source.remove(elements);
  }

  if(elements === this) {
    // Just remove everything
    [].splice.call(this, 0);
  }
  else {
    // Loop through the hard way
    for(i = elements.length; i--;) {
      elementIndex = this.indexOf(elements[i]);

      if(this[elementIndex]) {
        [].splice.call(this, elementIndex, 1);
      }
    }
  }

  return this;
};


/**
 * .filter()
 *
 * Returns a new List of elements matching the conditions
 *
 * @param conditions (Object|Function) The conditions to match or comparing method
 * @return (List) The matched set
 */

List.prototype.filter = function(conditions) {
  var result = new List({ source: this.options.source }),
      matcher = typeof conditions === 'function' ? conditions : match(conditions),
      i, l;

  if(Array.prototype.filter) {
    return result.merge([].filter.call(this, matcher));
  }

  // Custom filter implementation
  for(i = 0, l = this.length; i < l; i++) {
    if(match(this[i])) {
      result.add(this[i]);
    }
  }

  return result;
};


/**
 * .map()
 *
 * Regular Array.map() method whith the added ability to specify a property to
 * auto map.
 *
 * @param property (String) Name
 * @return (type) Description
 */

List.prototype.map = function(property) {
  var result = new List(),
      extractor = typeof property === 'function' ? property : extract(property),
      i, l;

  for(i = 0, l = this.length; i < l; i++) {
    result.add(extractor(this[i]));
  }

  return result;
};


/* Private functions
============================================================================= */


/**
 * match()
 *
 * Whether or not an element matches some conditions
 *
 * @param conditions (Object) Conditions
 * @return (Function)
 *  @param element (Object) Element to be matched
 *  @return (Boolean) Match or not
 */

function match (conditions) {
  return function (element) {
    var i;

    for(i in conditions) {
      if(List.findByPath(element, i) !== conditions[i]) {
        return false;
      }
    }

    return true;
  };
}


/**
 * extract()
 *
 * Return the property of an element
 *
 * @param paramName (type) Description
 * @return (type) Description
 */

function extract (property) {
  return function (element) {
    return List.findByPath(element, property);
  };
}


/* Aliases for imitating an array
============================================================================= */

List.prototype.push = function() {
  return this.merge(arguments);
};

List.prototype.unshift = function() {
  var i, element;

  // Add each element to the beginning, backwards
  for(i = arguments.length; i--;) {
    element = arguments[i];
    this.add(element, 0);
  }

  return this;
};

List.prototype.concat = function() {
  var result = new List(),
      src = arguments,
      i, l;

  result.merge(this);

  for(i = 0, l = src.length; i < l; i++) {
    result.merge(src[i]);
  }

  return result;
};

List.prototype.pop = function() {
  var result = this[this.length - 1];

  this.remove([result]);
  return result;
};

List.prototype.shift = function() {
  var result = this[0];

  this.remove([result]);
  return result;
};

List.prototype.splice = function(index, howMany, replace) {
  var result = new List(),
      length = arguments.length,
      i;

  // Prepare replacements
  replace = replace ? [replace] : [];

  if(length > 3) {
    replace = Array.prototype.slice.call(arguments, 2);
  }

  // Get elements
  result.merge(Array.prototype.slice.call(this, index, index + howMany));

  // Remove elements
  this.remove(result);

  // Add replacements one at a time, backwards
  for(i = replace.length; i--;) {
    this.add(replace[i], index);
  }

  return result;
};

},{}],13:[function(require,module,exports){
"use strict";

var List = require('./List'),
    Bucket = require('./Bucket'),
    Index;


/**
 * Index
 *
 * Class for storing objects in a hash where the property is a certain key of
 * each object. 
 *
 * @param [options] (Object) Property to index
 *  @param index (String) Property to index
 *  @param unique (Boolean) If true, elements will be added only if the indexed
 *    property has not been indexed already
 *  @param sparse (Boolean) If true, undefined values will not be added (note
 *    that other falsey values are not considered undefined)
 * @return (Object) this
 */

Index = exports = module.exports = function Index (options) {
  List.call(this, options, {
    index: '',
    unique: false,
    sparse: false
  });

  this.elements = {};

  return this;
};


/* Public methods
============================================================================= */

Index.prototype.add = function(element) {
  var i, l,
      elements = this.elements,
      index = this.options.index,
      value,
      bucket;

  // Extract indexable value
  if(index.indexOf('.')) {
    value = List.findByPath(element, index);
  }
  else if(element[index] !== undefined) {
    value = element[index];
  }

  // If sparse and undefined
  if(value === undefined && this.options.sparse === true) {
    return false;
  }

  bucket = elements[value];

  if(!bucket) {
    elements[value] = bucket = new Bucket({ unique: this.options.unique, source: this.options.source });
  }

  bucket.add(element);

  return true;
};


Index.prototype.find = function(value) {
  return this.elements[value] || new List({ unique: this.options.unique, source: this.options.source });
};

Index.prototype.remove = function(elements, _fromParent) {
  var i, bucket, bucketIndex;

  // Assuming an index always has a source
  if(!_fromParent) {
    this.options.source.remove(elements);
    return this;
  }

  // Assume elements is always specified, since it will never be called directly
  for(i = elements.length; i--;) {
    bucketIndex = elements[i][this.options.index];
    bucket = this.elements[bucketIndex];

    if(bucket && bucket.length) {
      bucket.remove(elements, true);

      if(!bucket.length) {
        delete this.elements[bucketIndex];
      }
    }
  }

  return this;
};

},{"./List":12,"./Bucket":14}],14:[function(require,module,exports){
"use strict";

var List = require('./List'),
    Bucket;

/**
 * Bucket
 *
 * Pretty much a List which knows if it's unique or not
 */


Bucket = exports = module.exports = function Bucket (options) {
  List.call(this, options, {
    unique: false
  });
};

Bucket.prototype = new List();
Bucket.prototype.constructor = Bucket;

Bucket.prototype.add = function(element, _where) {
  if(!this.length || !this.options.unique) {
    List.prototype.add.call(this, element, _where);
  }
};

},{"./List":12}]},{},[1])(1)
});
;